From 0d872e339967dd6eda50f643a3973d2e2394c7e7 Mon Sep 17 00:00:00 2001
From: Francois Andrieu <darknao@fedoraproject.org>
Date: Feb 26 2022 19:25:39 +0000
Subject: [PATCH 85/88] use pregenerated metadata from git in last-update extension


---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index a55ba97..df1ebc0 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -121,10 +121,24 @@ def generate_lang_switch_ui(languages):
 
     return "\n".join(template_list)
 
+def get_metadata_from_branch(branch, repodir):
+    cmd = f"""
+      for file in $(git ls-tree -r --name-only origin/{branch}|grep -E "adoc$"); do 
+        git log -1 --format="'$file':%n  refs: %S%n  hash: %h%n  date: %as" origin/{branch} -- $file;
+      done"""
+    s = subprocess.run(cmd, shell=True, cwd=repodir,  stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
+    return yaml.safe_load(s.stdout)
+
 def prefetch_sources(original_sources, site_yml, config):
     if not os.path.isdir(original_sources):
         os.mkdir(original_sources)
 
+    default_branch = site_yml["content"].get("branches", ["master"])
+    if type(default_branch) is str:
+        default_branch = [default_branch]
+
+    metadata = {}
+
     for repo_data in site_yml["content"]["sources"]:
       gitdir = tempfile.TemporaryDirectory(dir=original_sources)
       dirname = gitdir.name
@@ -133,6 +147,21 @@ def prefetch_sources(original_sources, site_yml, config):
       subprocess.run(["git", "clone", repo_data['url'], dirname])
       repo_data['url'] = dirname
 
+      branches = repo_data.get("branches", default_branch)
+      if type(branches) is str:
+        branches = [branches]
+
+      for branch in branches:
+        y = get_metadata_from_branch(branch, repo_data['url'])
+        if dirname in metadata:
+          metadata[dirname][branch] = y
+        else:
+          metadata[dirname] = { branch: y }
+
+    if metadata:
+      with open("/tmp/metadata.yml", "w") as f:
+        yaml.dump(metadata, f)
+
     return site_yml
 
 def prepare_translated_sources(translated_sources, site_yml, languages, config):
diff --git a/lib/extensions/page-last-update.js b/lib/extensions/page-last-update.js
index e0a1ae5..c60629f 100644
--- a/lib/extensions/page-last-update.js
+++ b/lib/extensions/page-last-update.js
@@ -2,33 +2,36 @@
 module.exports.register = function () {
   this.on('contentClassified', async ({ contentCatalog }) => {
     const logger = this.require('@antora/logger').get('page-last-update')
-    const git = this.require('@antora/content-aggregator/lib/git')
+    const yaml = this.require('js-yaml')
     const path = this.require('path')
     const fs = this.require('fs')
-    // logger.warn(contentCatalog)
-
     const pages = contentCatalog.findBy({ family: 'page' })
-    for (const page of pages) {
-      const relpath = path.join(page.src.origin.startPath, page.src.path)
-      logger.warn(relpath)
-      const contents = page.contents.toString('utf-8')
-
-      // Get git history
-      try {
-        const commits = await git.log({ fs, gitdir: page.src.origin.gitdir, filepath: relpath, ref: "origin/"+page.src.origin.refname, follow: true, depth: 1 })
-
-        // Get last commit date & author
-        const last_update = new Date(commits[0].commit.author.timestamp * 1000).toISOString().split('T')[0]
-        const last_author = commits[0].commit.author.name
+    const pageRx = new RegExp('modules/[^/]+/pages/(?:.+/)*[^.].*\.adoc$')
 
-        // Inject attribute in page content
-        const patchedContents = ":page-last-updated: " + last_update + "\n" + contents
-        page.contents = Buffer.from(patchedContents)
-      } catch (gitErr) {
-        logger.error("no history found")
-	continue
+    if (fs.existsSync("/tmp/metadata.yml")) {
+      let data = fs.readFileSync("/tmp/metadata.yml", "utf-8")
+      let y = yaml.loadAll(data)
+    
+      for (const page of pages) {
+        if (page.src.origin.type == "git" && pageRx.test(page.src.path)) {
+          const relpath = path.join(page.src.origin.startPath, page.src.path)
+          const abspath = page.src.origin.gitdir.replace(/\/\.git$/, "")
+          // logger.warn(abspath)
+          const contents = page.contents.toString('utf-8')
+          const branch = page.src.origin.branch
+          if (abspath in y[0] && branch in y[0][abspath] && relpath in y[0][abspath][branch]) {
+            let last_update = y[0][abspath][branch][relpath]["date"].toISOString().split('T')[0]
+            logger.warn({name: relpath, rev: branch, update: last_update})
+            
+            // Inject attribute in page content
+            const patchedContents = ":page-last-updated: " + last_update + "\n" + contents
+            page.contents = Buffer.from(patchedContents)
+          }
+        }
       }
 
+    } else {
+      logger.warn("no git metadata found, skipping...")
     }
     this.updateVariables({ contentCatalog })
   })

